import java.io.*;
import java.util.*;

public class Main {
    static int Xn, Yn, Wn;
    static String X, Y, W;
    static Map<Character, Pair> count_pair;
    static int pos_char;
    static int[] get_pref(String X, int Xn) {
        int[] pref = new int[Wn + 1];
        pref[0] = -1;
        for (int i = 1; i <= Wn; ++i) {
            pref[i] = pref[i - 1] + 1;
            while (X.charAt(pref[i]) != W.charAt(i - 1)) ++pref[i];
        }
        return pref;
    }
    static int[] get_suff(String X, int Xn) {
        int[] suff = new int[Wn + 1];
        suff[0] = Xn;
        for (int i = 1; i <= Wn; ++i) {
            suff[i] = suff[i - 1] - 1;
            while (X.charAt(suff[i]) != W.charAt(Wn - i)) --suff[i];
        }
        return suff;
    }
    static void add(char c, int v, int t) {
        Pair p;
        if (count_pair.containsKey(c)) {
            p = count_pair.get(c);
        }
        else {
            p = new Pair();
            count_pair.put(c, p);
        }
        if (p.x[0] > 0 && p.x[1] > 0) --pos_char;
        p.x[t - 1] += v;
        if (p.x[0] > 0 && p.x[1] > 0) ++pos_char;
    }
    static void solve() {
        count_pair = new HashMap<>();
        pos_char = 0;
        int[] X_pref = get_pref(X, Xn);
        int[] X_suff = get_suff(X, Xn);
        int[] Y_pref = get_pref(Y, Yn);
        int[] Y_suff = get_suff(Y, Yn);
        int xs = 0, xe = -1, ys = 0, ye = -1;
        for (int i = 0; i <= Wn; ++i) {
            while (xe < X_suff[Wn - i] - 1) add(X.charAt(++xe), 1, 1);
            while (ye < Y_suff[Wn - i] - 1) add(Y.charAt(++ye), 1, 2);
            while (xs < X_pref[i] + 1) add(X.charAt(xs++), -1, 1);
            while (ys < Y_pref[i] + 1) add(Y.charAt(ys++), -1, 2);
            if (pos_char > 0) {
                System.out.println("1");
                return;
            }
        }
        System.out.println("0");
    }
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int T = sc.nextInt();
        while (T-- > 0) {
            X = sc.next();
            Y = sc.next();
            W = sc.next();
            Xn = X.length();
            Yn = Y.length();
            Wn = W.length();
            solve();
        }
    }
}

class Pair {
    int[] x;
    Pair() {
        x = new int[2];
        x[0] = 0;
        x[1] = 0;
    }
}